CodeForces-711D Directed Roads(拓扑排序+组合数)

来源:互联网 发布:redis存储数据大小 编辑:程序博客网 时间:2024/05/01 17:10
D. Directed Roads
time limit per test
2 seconds
memory limit per test
256 megabytes
input
standard input
output
standard output

ZS the Coder and Chris the Baboon has explored Udayland for quite some time. They realize that it consists of n towns numbered from 1to n.

There are n directed roads in the Udayland. i-th of them goes from town i to some other town ai (ai ≠ i). ZS the Coder can flip the direction of any road in Udayland, i.e. if it goes from town A to town B before the flip, it will go from town B to town A after.

ZS the Coder considers the roads in the Udayland confusing, if there is a sequence of distinct towns A1, A2, ..., Ak (k > 1) such that for every 1 ≤ i < k there is a road from town Ai to town Ai + 1 and another road from town Ak to town A1. In other words, the roads are confusing if some of them form a directed cycle of some towns.

Now ZS the Coder wonders how many sets of roads (there are 2n variants) in initial configuration can he choose to flip such that after flipping each road in the set exactly once, the resulting network will not be confusing.

Note that it is allowed that after the flipping there are more than one directed road from some town and possibly some towns with no roads leading out of it, or multiple roads between any pair of cities.

Input

The first line of the input contains single integer n (2 ≤ n ≤ 2·105) — the number of towns in Udayland.

The next line contains n integers a1, a2, ..., an (1 ≤ ai ≤ n, ai ≠ i)ai denotes a road going from town i to town ai.

Output

Print a single integer — the number of ways to flip some set of the roads so that the resulting whole set of all roads is not confusing. Since this number may be too large, print the answer modulo 109 + 7.

题意:给出一个有向图,可以任意翻转任意边,要求其翻转后所有联通块都没有环,求翻转的方案数

题解:因为只有n条边,因此每个联通块中有且仅有1个环,先用拓扑排序,找出不成环的边的个数为k,不成环的边可以任意翻转,记录每个联通块剩下的成环的边的个数Mi,根据组合数的原理,C(0,n)+C(1,n)+...+C(n,n)=2^n,得出每个联通块中成环的边翻转所有的组合=2^Mi-2(不翻转和全部翻转都会有环,要舍去),然后答案ans=2^k*(2^M1-2)*(2^M2-2)*...

#include<cstdio>#include<queue>#include<string.h>#include<algorithm>using namespace std;const int maxn = 2e5 + 5;typedef long long LL;const LL mod = 1e9 + 7;struct Edge{    int v,nxt;}edge[maxn*2];struct Ans{    LL r,cnt;    bool operator<(const Ans& _A)const{        return r>_A.r;    }}ans[maxn];int head[maxn],tot,vis[maxn];int p[maxn],d[maxn];LL pow(LL a,LL b){    LL ret=1;    while(b){        if(b&1) ret=ret*a%mod;        a=a*a%mod;        b>>=1;    }    return ret;}void add(int u,int v){    edge[tot].v=v;    edge[tot].nxt=head[u];    head[u]=tot++;    d[v]++;}int find(int x){return p[x]==x?x:(p[x]=find(p[x]));}int main(){    int n;    memset(head,-1,sizeof(head));   // freopen("in.txt","r",stdin);    scanf("%d",&n);    for(int i=1;i<=n;i++) p[i]=i;    for(int u=1;u<=n;u++){        int v;        scanf("%d",&v);        add(u,v);add(v,u);        int p1=find(u),p2=find(v);        if(p1!=p2) p[p2]=p1;    }    queue<int>q;    for(int i=1;i<=n;i++) if(d[i]==1) q.push(i),vis[i]=1;    while(!q.empty()){        int u=q.front();q.pop();        for(int i=head[u];~i;i=head[u]){            int v=edge[i].v;            head[u]=edge[i].nxt;            d[v]--;            if(d[v]==1&&!vis[v]){                q.push(v);                vis[v]=1;            }        }    }    for(int i=1;i<=n;i++) {        ans[find(i)].r++;        if(!vis[i]) ans[find(i)].cnt++;    }    sort(ans+1,ans+n+1);    LL sum=1;    for(int i=1;i<=n;i++){        if(ans[i].r==0) break;       // printf("%I64d %I64d\n",ans[i].r,ans[i].cnt);        sum=(sum*(pow(2ll,ans[i].cnt)-2ll)%mod*pow(2ll,ans[i].r-ans[i].cnt))%mod;       // printf("%I64d\n",sum);    }    printf("%I64d\n",sum);    return 0;}


0 0